#include "jtraceAPI.h"
#include <stdio.h>
#include "../colors.h"


// Sample plugin for JTrace API - for qcrild
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
// Basically, you create a dylib, 
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//


extern int config_color (void);

int gColor ;

// ssize_t sendto(int sockfd, const void *buf, size_t len, int flags,
//                      const struct sockaddr *dest_addr, socklen_t addrlen);

int qcrild_sendto (regs_t *Regs, int Exit, int Pid)
{

	static int saved_fd;
	int readRC = 0;
	if (!Exit)
	{

		long arg0 = getRegValue(Regs,REG_ARG_0,0);
 		saved_fd = (int) arg0;
		long sendtoBuf = getRegValue(Regs,REG_ARG_1,0);
		int sendtoLen = (int) getRegValue(Regs,REG_ARG_2,0);

		if (arg0  > 255) { printf("sendto %ld?!\n", arg0);}
		if (gColor) printf(BOLD);
		printf("--sendto (");
		if (gColor) printf(NORMAL);
		printf ("%d", arg0);
		printf (",");


		char *local = malloc(sendtoLen);
		int rc = readProcessMemory(Pid, sendtoBuf, sendtoLen, local);

		void  hexDump (char *Buffer, int Len, uint64_t Address,int Indent);

		hexDump (local, sendtoLen,sendtoBuf,2);

		return 0;
	}
	else
	{
	// on exit, print values read. Use jtrace's readProcessMemory
	//
	} 
	if (gColor) { printf(NORMAL); }
	printf (")= %d", readRC);

	return 0;
} // lmkd_read 


int init = 0;
__attribute__((constructor)) void _init(void) {
	
	if (init) return;
	init++;	
	fprintf(stderr,"LOADED LMKD PLUGIN\n");
	gColor = config_color();


	int rc= registerSyscallHandler ("sendto", // char *SyscallName, // must exist or you'll get -1 
	        qcrild_sendto,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above


}


#if 0




#endif

